Robot Simulator of the Robotics Group for Self-Organization of Control: Arm2Segm Class Reference

# Arm2Segm Class Reference

`#include <arm2segm.h>`

Inherits lpzrobots::OdeRobot.

Collaboration diagram for Arm2Segm:
[legend]

List of all members.

## Public Member Functions
| Arm2Segm (const OdeHandle &odeHandle, const OsgHandle &osgHandle, const Arm2SegmConf)
virtual | ~Arm2Segm ()
virtual void | update ()
| update the subcomponents
virtual void | place (const osg::Matrix &pose)
| sets the pose of the vehicle
virtual int | getSensors (sensor *sensors, int sensornumber)
| returns actual sensorvalues
virtual void | setMotors (const motor *motors, int motornumber)
| sets actual motorcommands
virtual int | getSensorNumber ()
| returns number of sensors
virtual int | getMotorNumber ()
| returns number of motors
virtual int | getSegmentsPosition (std::vector< Position > &poslist)
| returns a vector with the positions of all segments of the robot
virtual Primitive * | getMainPrimitive () const
| the main object of the robot, which is used for position and speed tracking
virtual void | doInternalStuff (GlobalData &globalData)
| this function is called in each simulation timestep (always after control).
## Static Public Member Functions
static Arm2SegmConf | getDefaultConf ()
## Protected Member Functions
virtual void | create (const osg::Matrix &pose)
| creates vehicle at desired pose
virtual void | destroy ()
| destroys vehicle and space
## Protected Attributes
dSpaceID | parentspace
Arm2SegmConf | conf
std::vector< AngularMotor1Axis * > | amotors
std::string | name
paramval | speed
paramval | factorSensors
int | sensorno
int | motorno
bool | created

## Constructor & Destructor Documentation

Arm2Segm | ( | const OdeHandle & | odeHandle,
|  | const OsgHandle & | osgHandle,
|  | const Arm2SegmConf | armConf |
| ) |  |  |

virtual ~Arm2Segm | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

void create | ( | const osg::Matrix & | pose | ) | `[protected, virtual]`

creates vehicle at desired pose

creates vehicle at desired position

Parameters:

  | pose | 4x4 pose matrix

pose

pose

pose

void destroy | ( |  | ) | `[protected, virtual]`

destroys vehicle and space

void doInternalStuff | ( | GlobalData & | globalData | ) | `[virtual]`

this function is called in each simulation timestep (always after control).

It should perform robot-internal checks and actions like resetting certain sensors or implement velocity dependend friction and the like. The attached Motors should act here.

Parameters:

  | globalData | structure that contains global data from the simulation environment

Reimplemented from OdeRobot.

static Arm2SegmConf getDefaultConf | ( |  | ) | `[inline, static]`

Primitive * getMainPrimitive | ( |  | ) | const`[virtual]`

the main object of the robot, which is used for position and speed tracking

Reimplemented from OdeRobot.

virtual int getMotorNumber | ( |  | ) | `[inline, virtual]`

returns number of motors

Implements AbstractRobot.

int getSegmentsPosition | ( | std::vector< Position > & | poslist | ) | `[virtual]`

returns a vector with the positions of all segments of the robot

Parameters:

  | poslist | vector of positions (of all robot segments)

Returns:
  length of the list

virtual int getSensorNumber | ( |  | ) | `[inline, virtual]`

returns number of sensors

Implements AbstractRobot.

int getSensors | ( | sensor * | sensors,
|  | int | sensornumber |
| ) |  |  | `[virtual]`

returns actual sensorvalues

Parameters:

  | sensors | sensors scaled to [-1,1]
  | sensornumber | length of the sensor array

Returns:
  number of actually written sensors

Parameters:

  | sensors | sensors scaled to [-1,1] (more or less)
  | sensornumber | length of the sensor array

Returns:
  number of actually written sensors

Implements AbstractRobot.

void place | ( | const osg::Matrix & | pose | ) | `[virtual]`

sets the pose of the vehicle

sets the vehicle to position pos, sets color to c, and creates robot if necessary

Parameters:

  | pose | desired 4x4 pose matrix
  | pose | desired position of the robot in struct Position

Implements OdeRobot.

void setMotors | ( | const motor * | motors,
|  | int | motornumber |
| ) |  |  | `[virtual]`

sets actual motorcommands

Parameters:

  | motors | motors scaled to [-1,1]
  | motornumber | length of the motor array

Implements AbstractRobot.

void update | ( |  | ) | `[virtual]`

update the subcomponents

Implements OdeRobot.

## Member Data Documentation

std::vector<AngularMotor1Axis*> amotors`[protected]`

Arm2SegmConf conf`[protected]`

bool created`[protected]`

paramval factorSensors`[protected]`

int motorno`[protected]`

std::string name`[protected]`

Reimplemented from Configurable.

dSpaceID parentspace`[protected]`

Reimplemented from OdeRobot.

int sensorno`[protected]`

paramval speed`[protected]`

The documentation for this class was generated from the following files:

- arm2segm.h
- arm2segm.cpp